<template>
  <div>
    <!-- check genric table uses this table elements  -->
    <!-- table starts from here -->
    <el-table :data="data" border resizable :loading="loading">
      <el-table-column type="index" label="#" fixed></el-table-column>
      <el-table-column
        prop="repo_id"
        label="Repo-Id"
        width="150px"
      ></el-table-column>
      <el-table-column
        prop="repo_name"
        label="Repo-Name"
        width="190px"
      ></el-table-column>
      <el-table-column prop="repo_url" label="Repo-Url">
        <template slot-scope="scope">
          <a style="cursor: pointer" :href="scope.row.repo_url">{{
            scope.row.repo_url
          }}</a>
        </template>
      </el-table-column>
      <el-table-column
        prop="no_of_approvers"
        label="Required Numbers of Approvers"
        width="142px"
      ></el-table-column>
      <el-table-column prop="approvers" label="Mandatory Approvers">
        <template slot-scope="scope">
          <div
            slot="reference"
            v-for="item in scope.row.approvers"
            :key="item.index"
          >
            {{ item.approvers_approvers_id.email }}
          </div>
        </template>
      </el-table-column>
      <el-table-column align="center" prop="action" label="Action" width="250">
        <template slot-scope="scope">
          <div
          >
            <el-row :gutter="20">
              <el-col :span="10">
                <GenericPopup
                  popup="EditRepoPopUp"
                  :data="data[scope.$index]"
                  :apiParams="apiParams"
                />
              </el-col>
              <el-col>
                <el-button
                  type="success"
                  round
                  class="button"
                  @click="
                    routeToMergeList(scope.row.repo_id, scope.row.repo_url)
                  "
                  >View Merge Requests</el-button
                >
              </el-col>
              
            </el-row>
          </div>
        </template>
      </el-table-column>
    </el-table>
    <!-- table ends here -->
  </div>
</template>

<script>
import { mapState } from "vuex";
import GenericPopup from "./popups/GenericPopup.vue";
export default {
  name: "RepoTable",
  props: ["apiParams", "data"],
  components: {
    GenericPopup,
  },

  computed: {
    ...mapState({
      loading: (state) => state.loading,
      userName: (state) => state.userName,
      email: (state) => state.email,
      admins: (state) => state.env.VUE_APP_DASHBOARD_ADMIN,
    }),
  },
  methods: {
    checkifapproverexist(param) {
      let bool = false;
      param.forEach((element) => {
        if (
          element.approvers_approvers_id.email == this.$store.state.userName
        ) {
          bool = true;
        }
      });
      return bool;
    },
    checkIfAdmin() {
      let bool = false;
      let envValue = this.admins;
      let adminArr = envValue.split(",");
      adminArr.forEach((element) => {
        if (this.email == element) {
          bool = true;
        }
      });
      return bool;
    },
    routeTopipeline(repoid, repo_url) {
      let baseUrl = new URL(repo_url).origin;
      this.$router.push(`/pipeline/${repoid}?baseurl=${baseUrl}`);
    },
     routeToMergeList(repoId, repo_url) {
      let baseUrl = new URL(repo_url).origin;
      this.$router.push(`/merge-screen/${repoId}?baseurl=${baseUrl}`);
    },
  },
};
</script>
<style>
.button {
  margin-left: 10px;
  margin-top: 10px;
}
</style>